# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CategoryGrowthRates(UniversalBaseModel):
    date: str = pydantic.Field()
    """
    The date of the entry.
    """

    category: str = pydantic.Field()
    """
    The category of the entry.
    """

    cmgr_3: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cmgr3")
    ] = pydantic.Field(default=None)
    """
    3-month category growth rate, for monthly frequency.
    """

    cmgr_6: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cmgr6")
    ] = pydantic.Field(default=None)
    """
    6-month category growth rate, for monthly frequency.
    """

    cmgr_12: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cmgr12")
    ] = pydantic.Field(default=None)
    """
    12-month category growth rate, for monthly frequency.
    """

    cqgr_1: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cqgr1")
    ] = pydantic.Field(default=None)
    """
    1-quarter category growth rate, for quarterly frequency.
    """

    cqgr_2: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cqgr2")
    ] = pydantic.Field(default=None)
    """
    2-quarter category growth rate, for quarterly frequency.
    """

    cqgr_4: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cqgr4")
    ] = pydantic.Field(default=None)
    """
    4-quarter category growth rate, for quarterly frequency.
    """

    cagr_1: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cagr1")
    ] = pydantic.Field(default=None)
    """
    1-year category growth rate, for annual frequency.
    """

    cagr_2: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cagr2")
    ] = pydantic.Field(default=None)
    """
    2-year category growth rate, for annual frequency.
    """

    cagr_4: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="cagr4")
    ] = pydantic.Field(default=None)
    """
    4-year category growth rate, for annual frequency.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
