# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
from .frequency import Frequency
import pydantic
from .income_statement_entry import IncomeStatementEntry
from .category_growth_rates import CategoryGrowthRates
from .financial_metrics import FinancialMetrics
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class FinancialsResponse(UniversalBaseModel):
    freq: typing.Optional[Frequency] = pydantic.Field(default=None)
    """
    The frequency of the financial data.
    """

    income_statement: typing.Optional[typing.List[IncomeStatementEntry]] = (
        pydantic.Field(default=None)
    )
    """
    The entries in the income statement.
    """

    category_growth_rates: typing.Optional[typing.List[CategoryGrowthRates]] = (
        pydantic.Field(default=None)
    )
    """
    The growth rates for each category. The c{x}gr values will occur where x matches the frequency.
    """

    financial_metrics: typing.Optional[typing.List[FinancialMetrics]] = pydantic.Field(
        default=None
    )
    """
    Derived financial metrics for the company.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
